#include "PrinterAddon.h"
PrinterAddon::PrinterAddon()
:fimageid(-1)
,fminpagewidth(0)
,fminpageheight(0)
,fmaxpagewidth(0)
,fmaxpageheight(0)
,fauthor("")
,fsupportpapermedia(NULL)
,fqualitycolor(NULL)
,fqualitymono(NULL)
{

}
PrinterAddon::~PrinterAddon()
{
  UnloadAddon();
}
void PrinterAddon::UnloadAddon()
{
  if (fimageid >= B_OK)
  {
    unload_add_on(fimageid);
    fimageid = -1;
    /*
    fauthor = "";
    if (fqualitycolor != NULL)
    delete fqualitycolor;
    fqualitycolor = NULL;
    if (fqualitymono != NULL)
    delete fqualitymono;
    fqualitymono  = NULL;
    fsupportpapermedia = NULL;
    */
  }
}
status_t PrinterAddon::LoadAddon(const char *path)
{
  UnloadAddon();
  fimageid = load_add_on(path);
  if (fimageid < B_OK)
  {
    UnloadAddon();
    return B_ERROR;
  }
  // now testing the addon
  if (!VerifyAddon())
  {
    UnloadAddon();
    return B_ERROR;
  }
  return B_OK;
}
status_t PrinterAddon::InitCheck()
{
  if (fimageid < B_OK)
  return B_ERROR;
  return B_OK;
}
uint32 PrinterAddon::MinPageWidth()
{
  return fminpagewidth;
}
uint32 PrinterAddon::MinPageHeight()
{
  return fminpageheight;
}
uint32 PrinterAddon::MaxPageWidth()
{
  return fmaxpagewidth;
}
uint32 PrinterAddon::MaxPageHeight()
{
  return fmaxpageheight;
}
const char *PrinterAddon::Author()
{
  return fauthor.String();
}
bool PrinterAddon::SupportColorPrint()
{
  return fsupportcolorprint;
}
print_quality_st *PrinterAddon::SupportQualityColor()
{
  return fqualitycolor;
}
print_quality_index_st *PrinterAddon::SupportQualityIndexColor()
{
  return fqualityindexcolor;
}

print_quality_st *PrinterAddon::SupportQualityMono()
{
  return fqualitymono;
} 
print_quality_index_st *PrinterAddon::SupportQualityIndexMono()
{
  return fqualityindexcolor;
}

support_paper_media_st *PrinterAddon::SupportPaperMedia()
{
  return fsupportpapermedia;
}
bool PrinterAddon::VerifyAddon()
{
  void *func;
  
  if (get_image_symbol(fimageid,"MinimunPageWidth",B_SYMBOL_TYPE_TEXT,&func) < B_OK)
  return false;
  fminpagewidth = ((uint32 (*)()) func)();   
  
  if (get_image_symbol(fimageid,"MinimunPageHeight",B_SYMBOL_TYPE_TEXT,&func) < B_OK)
  return false;
  fminpageheight = ((uint32 (*)()) func)();   

  if (get_image_symbol(fimageid,"MaximunPageWidth",B_SYMBOL_TYPE_TEXT,&func) < B_OK)
  return false;
  fmaxpagewidth = ((uint32 (*)()) func)();   

  if (get_image_symbol(fimageid,"MaximunPageHeight",B_SYMBOL_TYPE_TEXT,&func) < B_OK)
  return false;
  fmaxpageheight = ((uint32 (*)()) func)();   
  
  if (get_image_symbol(fimageid,"Author",B_SYMBOL_TYPE_TEXT,&func) < B_OK)
  return false;
  fauthor = ((const char *(*)()) func)();

  if (get_image_symbol(fimageid,"SupportColorPrint",B_SYMBOL_TYPE_TEXT,&func) < B_OK)
  return false;
  fsupportcolorprint = ((const char *(*)()) func)();
 
  if (get_image_symbol(fimageid,"support_paper_media",B_SYMBOL_TYPE_DATA,&func) < B_OK)
  fsupportpapermedia = NULL;
  else
  fsupportpapermedia = (support_paper_media_st *) func;

  if (get_image_symbol(fimageid,"support_quality_color",B_SYMBOL_TYPE_DATA,&func) < B_OK)
  fqualitycolor = NULL;
  else
  fqualitycolor = (print_quality_st *) func;

  if (get_image_symbol(fimageid,"support_quality_index_color",B_SYMBOL_TYPE_DATA,&func) < B_OK)
  fqualityindexcolor = NULL;
  else
  fqualityindexcolor = (print_quality_index_st *) func;
  
  if (get_image_symbol(fimageid,"support_quality_mono",B_SYMBOL_TYPE_DATA,&func) < B_OK)
  fqualitymono = NULL;
  else
  fqualitymono = (print_quality_st *) func;

  if (get_image_symbol(fimageid,"support_quality_index_mono",B_SYMBOL_TYPE_DATA,&func) < B_OK)
  fqualityindexmono = NULL;
  else
  fqualityindexmono = (print_quality_index_st *) func;
  
  return true;
}