#ifndef PRINTERADDON_H
#define PRINTERADDON_H
#include <OS.h>
#include <image.h>
#include <String.h>
#include <AddonDefs.h>
class PrinterAddon
{
  public:
    PrinterAddon();
    ~PrinterAddon();
    status_t LoadAddon(const char *path);
    status_t InitCheck();
    uint32 MinPageWidth();
    uint32 MinPageHeight();
    uint32 MaxPageWidth();
    uint32 MaxPageHeight();
    const char *Author();
    bool SupportColorPrint();
    support_paper_media_st *SupportPaperMedia();
    
    print_quality_st *SupportQualityColor();
    print_quality_index_st *SupportQualityIndexColor();
    print_quality_st *SupportQualityMono();
    print_quality_index_st *SupportQualityIndexMono();
  private:
    bool VerifyAddon();  
    void UnloadAddon();
  private:
    image_id fimageid;
    uint32 fminpagewidth;
    uint32 fminpageheight;
    uint32 fmaxpagewidth;
    uint32 fmaxpageheight;
    BString fauthor;
    bool    fsupportcolorprint;
    support_paper_media_st *fsupportpapermedia;
    print_quality_st *fqualitycolor;
    print_quality_index_st *fqualityindexcolor;
    print_quality_st *fqualitymono;
    print_quality_index_st *fqualityindexmono;
};
#endif