#include "PrinterInfo.h"
PrinterInfo::PrinterInfo()
:fmemory(0)
{
  funit = PRINTER_UNIT_INCH;
}
PrinterInfo::~PrinterInfo()
{

}
    
void PrinterInfo::PrinterModel(const char *value)
{
  fmodel = value;
}
const char *PrinterInfo::PrinterModel()
{
  if (fmodel.Length() > 0)
  return fmodel.String();
  return NULL;
}
    
void PrinterInfo::Unit(uint8 value)
{
  funit = value;
}
uint8 PrinterInfo::Unit()
{
  return funit;
}
    
void PrinterInfo::Memory(uint32 value)
{
  fmemory = value; 
}
uint32 PrinterInfo::Memory()
{
  return fmemory;
}
const char *PrinterInfo::PrinterName()
{
  return fprintername.String();
}
void PrinterInfo::Read(BNode *printer_file)
{
  char buffer[256];
  ssize_t n;
  // read printer name
  n = printer_file->ReadAttr(PrinterInfoSpace::PrinterNameAttrname,B_STRING_TYPE,0,buffer,sizeof(buffer));
  if (n >= 0)
  fprintername.SetTo(buffer,n);
  else
  fprintername.SetTo("");
  
  // read printer model
  n = printer_file->ReadAttr(PrinterInfoSpace::ModelAttrname,B_STRING_TYPE,0,buffer,sizeof(buffer));
  if (n >= 0)
  fmodel.SetTo(buffer,n);
  else
  fmodel.SetTo("");
  // read printer unit
  n = printer_file->ReadAttr(PrinterInfoSpace::UnitAttrname,B_UINT8_TYPE,0,&funit,sizeof(funit));
  if (n < (ssize_t) sizeof(funit))
  funit = PRINTER_UNIT_INCH;

  // read printer memory
  n = printer_file->ReadAttr(PrinterInfoSpace::MemoryAttrname,B_INT32_TYPE,0,&fmemory,sizeof(fmemory));
  if (n != sizeof(fmemory))
  fmemory = 0;
  else if (fmemory < 0)
  fmemory = 0;
}
void PrinterInfo::Write(BNode *printer_file)
{
  // write printer model
  printer_file->WriteAttr(PrinterInfoSpace::ModelAttrname,B_STRING_TYPE,0,fmodel.String(),fmodel.Length());
  // write printer unit
  printer_file->WriteAttr(PrinterInfoSpace::UnitAttrname,B_UINT8_TYPE,0,&funit,sizeof(funit));
  // write printer memory
  printer_file->WriteAttr(PrinterInfoSpace::MemoryAttrname,B_INT32_TYPE,0,&fmemory,sizeof(fmemory));
}

