#ifndef PRINTERSETUPWINDOW_H
#define PRINTERSETUPWINDOW_H
#include <Window.h>
#include <Box.h>
#include <ScrollView.h>
#include <ListView.h>
#include <ListItem.h>
#include <RadioButton.h>
#include <Slider.h>
#include <Button.h>
#include <OS.h>
#include <StorageKit.h>
#include <Directory.h>

#include "PrinterInfo.h"
#include "GUIUtils.h"
namespace PrinterSetupWindowSpace
{
  const int DEF_WIDTH = 320;
  const int DEF_HEIGHT = 247;
  
  // message
  const uint32 MSGCODE_SELECTION_CHANGE = 'MSG0' + 1;
  const uint32 MSGCODE_OK				= 'MSG0' + 2;
  const uint32 MSGCODE_CANCEL			= 'MSG0' + 3;
  
  const char LB_PRINTER_MODEL[] = "Printer model";
  const char LB_UNIT[]			= "Units";
  const char LB_INCH[]			= "Inch";
  const char LB_CM[]			= "cm";
  const char LB_MEMORY[]		= "Memory";
  const char LB_PHYSICAL_MEM[]	= "Physical memory used";
  const char LB_MIN_PERCENTAGE[] = "0%";
  const char LB_MAX_PERCENTAGE[] = "100%";
  const char LB_BTN_SAVE[]		= "Save";
  const char LB_BTN_DONT_SAVE[]	= "Don\'t save"; 
};
class PrinterSetupWindow : public BWindow
{
  public:
    PrinterSetupWindow(const char *driver_name);
    virtual void Quit();
    virtual void MessageReceived(BMessage *msg);
    virtual status_t Go(PrinterInfo *);
  private:
    void OnChange();
    void OnOK();
    void OnCancel();
  private:
    void LoadModelList();
  private:
    PrinterInfo  *fprinter_info;
    status_t     *fresult;
    sem_id       fsem;
    // gui  
    BButton      *btn_ok;
    BButton      *btn_cancel;
    BListView    *lv_model;
    BRadioButton *rb_inch;
    BRadioButton *rb_cm;
    BSlider      *sd_memory;
    
    int32        select_index;
};
#endif
