#include "PrintingModeView.h"
PrintingModeView::PrintingModeView(BRect rect,bool color_printer)
:BView(rect,NULL,B_FOLLOW_NONE,B_WILL_DRAW)
,fcolorprinter(color_printer)
{
  SetViewColor(B_TRANSPARENT_COLOR);
  // load bitmap
  BBitmap *tempbitmap;
  tempbitmap = new BBitmap(BRect(0,0,PrintingModeColorBitmapSpace::kDataWidth - 1,PrintingModeColorBitmapSpace::kDataHeight - 1),PrintingModeColorBitmapSpace::kDataColorSpace);
  tempbitmap->SetBits((void *) PrintingModeColorBitmapSpace::kDataBits,PrintingModeColorBitmapSpace::kDataWidth * PrintingModeColorBitmapSpace::kDataHeight,0,PrintingModeColorBitmapSpace::kDataColorSpace);
  fbitmap[0] = tempbitmap;  
  // bitmap mono color mode bitmap
  tempbitmap = new BBitmap(BRect(0,0,PrintingModeMonoBitmapSpace::kDataWidth - 1,PrintingModeMonoBitmapSpace::kDataHeight - 1),PrintingModeMonoBitmapSpace::kDataColorSpace);
  tempbitmap->SetBits((void *) PrintingModeMonoBitmapSpace::kDataBits,PrintingModeMonoBitmapSpace::kDataWidth * PrintingModeMonoBitmapSpace::kDataHeight,0,PrintingModeMonoBitmapSpace::kDataColorSpace);
  fbitmap[1] = tempbitmap;
  
}
PrintingModeView::~PrintingModeView()
{
  for (int i = 0; i < 2;i++)
  delete fbitmap[i];
}
void PrintingModeView::Draw(BRect updateRect)
{
  BBitmap *bitmap;
  if (fcolorprinter)
  bitmap = fbitmap[0];
  else
  bitmap = fbitmap[1];
  BRect bound = Bounds();
  SetHighColor(216,216,216,0);
  FillRect(bound);
  BRect brect = bitmap->Bounds();
  MovePenTo((bound.Width() - brect.Width()) / 2,(bound.Height() - brect.Height()) / 2);
  DrawBitmap(bitmap);  
}
bool PrintingModeView::ColorPrinter()
{
  return fcolorprinter;
}
void PrintingModeView::ColorPrinter(bool value)
{
  fcolorprinter = value;
  Invalidate();
}