#include "PrintingQualityView.h"
PrintingQualityView::PrintingQualityView(BRect rect,uint8 range,uint8 value)
:BView(rect,NULL,B_FOLLOW_NONE,B_WILL_DRAW)
,frange(range),fvalue(value)
{
  SetViewColor(B_TRANSPARENT_COLOR);
  // load bitmap  
  BBitmap *tempbitmap;
  // poor quality bitmap;
  tempbitmap = new BBitmap(BRect(0,0,QualityPoorBitmapSpace::kDataWidth - 1,QualityPoorBitmapSpace::kDataHeight - 1),QualityPoorBitmapSpace::kDataColorSpace);
  tempbitmap->SetBits((void *) QualityPoorBitmapSpace::kDataBits,QualityPoorBitmapSpace::kDataWidth * QualityPoorBitmapSpace::kDataHeight,0,QualityPoorBitmapSpace::kDataColorSpace);
  fbitmap[0] = tempbitmap;  
  // normal quality bitmap
  tempbitmap = new BBitmap(BRect(0,0,QualityNormalBitmapSpace::kDataWidth - 1,QualityNormalBitmapSpace::kDataHeight - 1),QualityNormalBitmapSpace::kDataColorSpace);
  tempbitmap->SetBits((void *) QualityNormalBitmapSpace::kDataBits,QualityNormalBitmapSpace::kDataWidth * QualityNormalBitmapSpace::kDataHeight,0,QualityNormalBitmapSpace::kDataColorSpace);
  fbitmap[1] = tempbitmap;
  // best quality bitmap
  tempbitmap = new BBitmap(BRect(0,0,QualityBestBitmapSpace::kDataWidth - 1,QualityBestBitmapSpace::kDataHeight - 1),QualityBestBitmapSpace::kDataColorSpace);
  tempbitmap->SetBits((void *) QualityBestBitmapSpace::kDataBits,QualityBestBitmapSpace::kDataWidth * QualityBestBitmapSpace::kDataHeight,0,QualityBestBitmapSpace::kDataColorSpace);
  fbitmap[2] = tempbitmap;
}
PrintingQualityView::~PrintingQualityView()
{
  for (int i = 0;i < 3;i++)
  delete fbitmap[i];
}
void PrintingQualityView::Draw(BRect updateRect)
{
  BBitmap *bitmap;
  if (frange < 1)
  bitmap = fbitmap[2];
  else if (frange < 2)
  bitmap = fbitmap[(fvalue / frange) + 1];
  else
  bitmap = fbitmap[fvalue / (frange / 2)];
  
  BRect bound = Bounds();
  SetHighColor(216,216,216,0);
  FillRect(bound);
  BRect brect = bitmap->Bounds();
  MovePenTo((bound.Width() - brect.Width()) / 2,(bound.Height() - brect.Height()) / 2);
  DrawBitmap(bitmap);
}

void PrintingQualityView::Range(uint8 range)
{
  frange = range;
}
uint8  PrintingQualityView::Range()
{
  return frange;
}
void   PrintingQualityView::Value(uint8 value)
{
  fvalue = value;
}
uint8  PrintingQualityView::Value()
{
  return fvalue;
}
