#include "driver.h"
#include <stdio.h>
#include <memory.h>
#include <StorageKit.h>
#include <Directory.h>
#include "PrinterSetupWindow.h"
#include "PageDefs.h"
#include "PageSetupWindow.h"
#include "JobSetupWindow.h"
#include "PrinterInfo.h"
#include "PrinterAddon.h"
// -------------------------------------------------------------------
// TAKE JOB
BMessage *take_job(BFile *spool_file,BNode *spool_dir,BMessage *msg)
{
  return NULL;
  /*
  PrinterDriver *driver;
  BMessage *ret_msg;
  driver = instanciate_driver(spool_dir);
  if (driver->PrintJob(spool_file,spool_dir,msg) == B_OK)
  ret_msg = new BMessage('okok');
  else
  ret_msg =  new BMessage('baad');
  delete driver;  
  return ret_msg;
  */
}
// -------------------------------------------------------------------

// -------------------------------------------------------------------
// CONFIG Page
BMessage *config_page(BNode *spool_dir,BMessage *msg)
{
  PageSetupWindow *page_setup_win;
  BMessage *pagesetup_msg;
  PrinterAddon addon;
  PrinterInfo  printer_info;

  printer_info.Read(spool_dir);
  if (addon.LoadAddon(printer_info.PrinterModel()) != B_OK)
  return NULL;
  
  pagesetup_msg = new BMessage(*msg);
  page_setup_win = new PageSetupWindow(&addon,printer_info.Unit());
  page_setup_win->Go(pagesetup_msg);
  if (pagesetup_msg->what == 'okok')
  return pagesetup_msg;  

  delete pagesetup_msg;
  return NULL; 
}
// -------------------------------------------------------------------

// -------------------------------------------------------------------
// Config Job
BMessage *config_job(BNode *spool_dir,BMessage *msg)
{
  JobSetupWindow *job_setup_win;
  BMessage *jobsetup_msg;
  PrinterAddon addon;
  PrinterInfo  printer_info;

  printer_info.Read(spool_dir);
  if (addon.LoadAddon(printer_info.PrinterModel()) != B_OK)
  return NULL;

  jobsetup_msg = new BMessage(*msg);
  job_setup_win = new JobSetupWindow(printer_info.PrinterName(),&addon,jobsetup_msg);
  job_setup_win->Go();

  if (jobsetup_msg->what == 'okok')
  return jobsetup_msg;  

  delete jobsetup_msg;
  return NULL; 
}
// -------------------------------------------------------------------


// -------------------------------------------------------------------
// Add Printer
char *add_printer(char *printer_name)
{
  BDirectory *node;
  PrinterSetupWindow *printer_setup;
  BPath path;
  PrinterInfo printer_info;
   
  // show printer model dialog
  printer_setup = new PrinterSetupWindow(printer_name);
  
  if (printer_setup == NULL)
  goto err_0;
  
  if (printer_setup->Go(&printer_info) == B_OK)
  {
    // find the directory
    if (find_directory(B_COMMON_SETTINGS_DIRECTORY,&path,true) != B_OK)
    goto err_0;
    // append path 
    path.Append("printers");
    path.Append(printer_name);
    // now open the node
    node = new BDirectory(path.Path());
    // save printer info into printer node attributes
    node->Lock();
    printer_info.Write(node);
    node->Unlock();
    delete node;
    return printer_name;
  }
  // err 0
  err_0:
  return NULL;  
}
// -------------------------------------------------------------------