#ifndef MEDIATYPE_H
#define MEDIATYPE_H
typedef enum
{
  printing_quality_economy		= 0,
  printing_quality_normal_240	= 1,
  printing_quailty_normal_360	= 2, 
  printing_quality_normal_480	= 3,
  printing_quality_fine_360		= 4,
  printing_quality_photo_720	= 5,
  printing_quality_photo_1440	= 6
}printing_quality_t;
typedef struct
{
  int16 xresolution;
  int16 yresolution;
}printing_density_t;

typedef struct
{
  const char 		 *name;
  printing_density_t density;
}printing_quality_info_t;

static printing_quality_info_t g_support_printing_quality_ifno[] =
{
  {{"Economy"}		,{360,120}},
  {{"Normal-240"}	,{480,240}},
  {{"Normal-360"}	,{360,360}},
  {{"Normal-480"}	,{360,480}},
  {{"Fine-360"}		,{360,720}},
  {{"Photo-720"}	,{720,720}},
  {{"Photo-1440"}	,{1440,720}}
};

typedef enum
{
  MEDIA_PLAIN_PAPER						= 0,
  MEDIA_360_INKJET_PAPER				= 1,
  MEDIA_PHOTO_QUALITY_INKJET_PAPER		= 2,
  MEDIA_MATTE_HEAVYWEIGHT_PAPER			= 3,
  MEDIA_PHOTO_PAPER						= 4,
  MEDIA_PHOTO_FILM_PAPER				= 5,
  MEDIA_INKJET_TRANSPARENTCY_PAPER		= 6,
  MEDIA_IRONON_TRANSFER_PAPER			= 7
}media_kind_t;

typedef struct
{
  printing_quality_t quality;
  bool bi_directional;
  bool microweave;
} media_print_option_t;
typedef struct
{
  const char *name;
  bool  bi_directional;
  int   support_quality_count;
  media_print_option_t support_quality[];
} media_printing_quality_info;

// color
static media_printing_quality_info g_support_media_printing_quality_info[]
{
  {{"Plain paper"},						3,	{
  												{printing_quality_economy,true,true},
  												{printing_quailty_normal_360,true,true},
  												{printing_quality_fine_360},true,true}
  										  	},
  {{"360 Inkjet paper"},				1,	{
  												{printing_quailty_normal_360,false,true}
  										  	},
  {{"Photo quality Inkjet paper"},		2,	{
  												{printing_quality_fine_360,true,true},
  												{printing_quality_photo_720,false,true}
  											},
  {{"Matte Heavyweight paper"},			2,	{
  												{printing_quality_fine_360,true,true},
  												{printing_quality_photo_720,false,true}
  											},
  {{"Photo paper"},						3,	{
  												{printing_quality_fine_360,true,true},
  												{printing_quality_photo_720,false,true},
  												{printing_quality_photo_1440,false,true}
  											},
  {{"Photo Quality Glossy film paper"},	2,	{
  												{printing_quality_photo_720,false,true},
  												{printing_quality_photo_1440,false,true}
  											},
  {{"Inkjet Transparencies paper"},		1,	{
  												{printing_quality_fine_360,false,true}
  											},
  {{"Iron-on cool transfer paper"},		1,	{	
  												{printing_quality_fine_360,true,true}
  											}
};
#endif